<template>
  <q-page padding>
    <div class="text-h5 q-mb-md">Insignias De Madera</div>

    <q-card class="q-mt-sm">
      <q-list bordered>
        <q-expansion-item icon="filter_alt" label="Filtros Avanzados">
          <template v-slot:header>
            <q-item-section> Filtros Avanzados </q-item-section>
            <q-item-section side v-if="IMsListadoStore.filtroActivado">
              <q-badge color="blue"> Existe un filtro aplicado </q-badge>
            </q-item-section>
          </template>
          <q-card>
            <q-card-section>
              <div class="q-col-gutter-md row">
                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="IMsListadoStore.filtros.query"
                  label="Buscar"
                  stack-label
                  dense
                />

                <selectRama
                  v-model="IMsListadoStore.filtros.rama"
                  dense
                  :multiple="false"
                  :filled="false"
                  label="Rama: "
                />

                <q-select
                  v-model="IMsListadoStore.filtros.afiliado"
                  style="min-width: 150px"
                  dense
                  use-chips
                  emit-value
                  stack-label
                  map-options
                  :options="[
                    { label: 'Afiliados', value: 'A' },
                    { label: 'Ex Adultos', value: 'I' },
                    { label: 'Todos', value: 'T' },
                  ]"
                  label="Adultos Afiliados"
                />
              </div>
            </q-card-section>
            <q-card-actions align="right">
              <q-btn flat color="primary" @click="onFiltrar">Filtrar</q-btn>
              <q-btn flat color="red" @click="onResetFiltros">
                Borrar Filtro
              </q-btn>
            </q-card-actions>
          </q-card>
        </q-expansion-item>
      </q-list>
    </q-card>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="IMsListadoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <KeepAlive>
              <PersonaDetalle :persona="props.row.persona" />
            </KeepAlive>
          </q-td>
        </template>

        <template v-slot:body-cell-funciones="props">
          <q-td :props="props">
            <PersonasFunciones :funciones="props.row.persona.funciones" />
          </q-td>
        </template>

        <template v-slot:body-cell-detalle="props">
          <q-td :props="props">
            <q-markup-table flat>
              <!-- separator="cell" bordered-->
              <tbody>
                <tr v-for="item in props.row.ims" :key="item.uuid">
                  <td>
                    <q-item dense>
                      <q-item-section>
                        <q-item-label caption lines="2">
                          <span>Nro Registro Asociativo :</span>
                          {{
                            item.nro_registro ? item.nro_registro : 'Pendiente'
                          }}
                        </q-item-label>
                        <q-item-label caption lines="3">
                          <span>Fecha Otorgada:</span>
                          {{ item.otorgada ? item.otorgada : 'Pendiente' }}
                        </q-item-label>
                      </q-item-section>
                    </q-item>
                  </td>
                  <td class="text-right">
                    <ItemRama :rama="item.rama" />
                  </td>

                  <td class="text-right">
                    <q-btn
                      v-if="$isCan('formacion.insignia_de_madera.edicion')"
                      color="blue"
                      size="sm"
                      icon="drive_file_rename_outline"
                      :to="'/formacion/insignia_de_madera/editar/' + item.uuid"
                    >
                      Editar
                    </q-btn>
                  </td>
                </tr>
              </tbody>
            </q-markup-table>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, reactive } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useInsigniaDeMaderaStore } from 'src/stores/formacion/InsigniaDeMaderaStore';
import PersonaDetalle from 'src/components/Personas/Detalle.vue';
import PersonasFunciones from 'src/components/Personas/Funciones.vue';
import ItemRama from 'src/components/Util/ItemRama.vue';
import SelectRama from 'src/components/Form/selectRama.vue';
import Loading from 'src/components/Loading.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  {
    name: 'funciones',
    label: 'Funciones',
    field: 'funciones',
    align: 'left',
  },
  { name: 'detalle', label: 'Detalle', field: 'detalle', align: 'left' },
];

export default defineComponent({
  components: {
    Loading,
    PersonaDetalle,
    PersonasFunciones,
    ItemRama,
    SelectRama,
  },
  name: 'InsigniaDeMaderaListadoPage',
  setup() {
    const loading = ref(true);
    const IMsListadoStore = useInsigniaDeMaderaStore();

    const filtros = reactive({
      tipo: 'miseventos',
      area: null,
      estado: 'activos',
    });

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      IMsListadoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      IMsListadoStore.filtroActivado = true;
      IMsListadoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/formacion/im', {
          params: IMsListadoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          IMsListadoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      IMsListadoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      columnas,
      dataSet,
      IMsListadoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      filtros,
      loading,
    };
  },
});
</script>
